Bug 835015 - Review Request: xmonad-log-applet - Panel applet to display Xmonad log information
Review Request: xmonad-log-applet - Panel applet to display Xmonad log inform...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Mario Blättermann
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-06-25 05:07 EDT by Dan Callaghan
Modified: 2012-09-21 20:11 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-09-21 20:11:52 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
mario.blaettermann: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Dan Callaghan 2012-06-25 05:07:00 EDT
Spec URL: http://fedorapeople.org/~dcallagh/xmonad-log-applet/xmonad-log-applet.spec
SRPM URL: http://fedorapeople.org/~dcallagh/xmonad-log-applet/xmonad-log-applet-2.0.0-1.fc17.src.rpm
Description: xmonad-log-applet is for Xmonad users who find the GNOME or Xfce panel useful. The applet will show the active workspaces, the title of the selected window, or any other information you send it from your xmonad.hs.
Fedora Account System Username: dcallagh

Note that in this package I'm only building the XFCE panel plugin, because the upstream build scripts only let me choose one of GNOME2, GNOME3, or XFCE, and XFCE is the one I care about. I'm open to suggestions on how to fix this.
Comment 1 Mario Blättermann 2012-07-09 14:37:25 EDT
> Note that in this package I'm only building the XFCE panel plugin, because
> the upstream build scripts only let me choose one of GNOME2, GNOME3, or
> XFCE, and XFCE is the one I care about. I'm open to suggestions on how to
> fix this.

Run the build script separately for each part. Just an idea, not tested:

%build

%configure --with-panel=xfce4
make %{?_smp_mflags}
make DESTDIR=%{buildroot} install
make clean

%configure --with-panel=gnome2
make %{?_smp_mflags}
make DESTDIR=%{buildroot} install
make clean

%configure --with-panel=gnome3
make %{?_smp_mflags}
make DESTDIR=%{buildroot} install

Could be that rpmlint is somewhat unhappy about "install" calls in %build... But it be odd if you provide a package which doesn't cover the whole abilities of the software. In any case, you should inform the upstream developers about that, if possible.
Comment 2 Mario Blättermann 2012-08-26 09:34:41 EDT
Ping...?
Comment 3 Dan Callaghan 2012-08-26 20:16:39 EDT
Sorry, I am still interested in this review but it's very far down my list of priorities.

Unfortunately your suggestion doesn't work exactly as is, Mario, because rpm cleans the buildroot at the start of %install so everything gets wiped out. But I could probably do something hacky like using DESTDIR=buildroot and then cp'ing from there into the real buildroot in %install. I will investigate later today.
Comment 4 Dan Callaghan 2012-08-27 00:06:57 EDT
Spec updated:

http://fedorapeople.org/~dcallagh/xmonad-log-applet/xmonad-log-applet.spec
http://fedorapeople.org/~dcallagh/xmonad-log-applet/xmonad-log-applet-2.0.0-2.fc17.src.rpm

I am just making two copies of the entire source tree in %prep, and then compiling it twice in %build and installing it twice in %install. Still kind of hacky but I think this is probably the cleanest solution. Now it produces two packages, xmonad-log-applet-xfce and xmonad-log-applet-gnome.
Comment 5 Mario Blättermann 2012-08-29 16:24:17 EDT
Taking this for review.
Comment 6 Mario Blättermann 2012-08-30 14:45:04 EDT
Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=4438643

$ rpmlint -i -v *
xmonad-log-applet.src: I: checking
xmonad-log-applet.src: W: spelling-error %description -l en_US workspaces -> work spaces, work-spaces, works paces
The value of this tag appears to be misspelled. Please double-check.

xmonad-log-applet.src: W: spelling-error %description -l en_US hs -> HS, sh, gs
The value of this tag appears to be misspelled. Please double-check.

xmonad-log-applet.src: I: checking-url https://github.com/alexkay/xmonad-log-applet (timeout 10 seconds)
xmonad-log-applet.src: I: checking-url https://github.com/downloads/alexkay/xmonad-log-applet/xmonad-log-applet-2.0.0.tar.gz (timeout 10 seconds)
xmonad-log-applet-debuginfo.i686: I: checking
xmonad-log-applet-debuginfo.i686: I: checking-url https://github.com/alexkay/xmonad-log-applet (timeout 10 seconds)
xmonad-log-applet-debuginfo.x86_64: I: checking
xmonad-log-applet-debuginfo.x86_64: I: checking-url https://github.com/alexkay/xmonad-log-applet (timeout 10 seconds)
xmonad-log-applet-gnome.i686: I: checking
xmonad-log-applet-gnome.i686: W: spelling-error %description -l en_US workspaces -> work spaces, work-spaces, works paces
The value of this tag appears to be misspelled. Please double-check.

xmonad-log-applet-gnome.i686: W: spelling-error %description -l en_US hs -> HS, sh, gs
The value of this tag appears to be misspelled. Please double-check.

xmonad-log-applet-gnome.i686: I: checking-url https://github.com/alexkay/xmonad-log-applet (timeout 10 seconds)
xmonad-log-applet-gnome.x86_64: I: checking
xmonad-log-applet-gnome.x86_64: W: spelling-error %description -l en_US workspaces -> work spaces, work-spaces, works paces
The value of this tag appears to be misspelled. Please double-check.

xmonad-log-applet-gnome.x86_64: W: spelling-error %description -l en_US hs -> HS, sh, gs
The value of this tag appears to be misspelled. Please double-check.

xmonad-log-applet-gnome.x86_64: I: checking-url https://github.com/alexkay/xmonad-log-applet (timeout 10 seconds)
xmonad-log-applet.spec: I: checking-url https://github.com/downloads/alexkay/xmonad-log-applet/xmonad-log-applet-2.0.0.tar.gz (timeout 10 seconds)
xmonad-log-applet-xfce.i686: I: checking
xmonad-log-applet-xfce.i686: W: spelling-error %description -l en_US workspaces -> work spaces, work-spaces, works paces
The value of this tag appears to be misspelled. Please double-check.

xmonad-log-applet-xfce.i686: W: spelling-error %description -l en_US hs -> HS, sh, gs
The value of this tag appears to be misspelled. Please double-check.

xmonad-log-applet-xfce.i686: I: checking-url https://github.com/alexkay/xmonad-log-applet (timeout 10 seconds)
xmonad-log-applet-xfce.x86_64: I: checking
xmonad-log-applet-xfce.x86_64: W: spelling-error %description -l en_US workspaces -> work spaces, work-spaces, works paces
The value of this tag appears to be misspelled. Please double-check.

xmonad-log-applet-xfce.x86_64: W: spelling-error %description -l en_US hs -> HS, sh, gs
The value of this tag appears to be misspelled. Please double-check.

xmonad-log-applet-xfce.x86_64: I: checking-url https://github.com/alexkay/xmonad-log-applet (timeout 10 seconds)
7 packages and 1 specfiles checked; 0 errors, 10 warnings.


A few spelling errors, to be ignored.


There are still some problems:

All entries in %doc and the png file appear in both packages. This will cause a package conflict if someone tries to install both. My proposal: Put the mentioned files in the base package (which actually doesn't exist yet) and don't forget to let it be required by both subpackages.

The -gnome package pulls only libpanel-applet-4.so.0 as a dependency, means that the folder %{_datadir}/gnome-panel/4.0/applets/ needs to be owned. Add gnome-panel manually, which solves this problem. The same in the -xfce package, which needs xfce4-panel as a runtime requirement. After all, shouldn't be Xmonad to be added as a dependency to the main package?

Maybe we need a way to force the user to don't install the base package only, which wouldn't make sense. Either -gnome or -xfce should be needed. My idea: Add a "Provides: xmonad-log-applet-foo" to both packages and vice versa a "Requires: xmonad-log-applet-foo" to the main package. But I don't know if Yum can solve this correctly. I assume that the user will be asked for installing each of the packages.
Comment 7 Dan Callaghan 2012-09-03 06:32:29 EDT
Thanks for taking this review, Mario.

(In reply to comment #6)
> There are still some problems:
> 
> All entries in %doc and the png file appear in both packages. This will
> cause a package conflict if someone tries to install both. My proposal: Put
> the mentioned files in the base package (which actually doesn't exist yet)
> and don't forget to let it be required by both subpackages.

Actually there is no conflict if the files are identical, which they always will be since they are built from the same sources. yum/rpm will happily install them both at the same time. I'd rather avoid having a base package if possible, since it makes things messier.

Though for a clean upgrade path, I should add an explicit Conflicts for < %{version}%{release}, so that yum knows to upgrade both at the same time (if both are installed). I have added that in -3.

> The -gnome package pulls only libpanel-applet-4.so.0 as a dependency, means
> that the folder %{_datadir}/gnome-panel/4.0/applets/ needs to be owned. Add
> gnome-panel manually, which solves this problem. The same in the -xfce
> package, which needs xfce4-panel as a runtime requirement.

Good point. Fixed in -3.

> After all,
> shouldn't be Xmonad to be added as a dependency to the main package?

I don't think so... There is no hard requirement for xmonad to be present for the package to work, and the user might be doing something unusual like sending their xmonad log messages over D-Bus over the network, or even just running their own custom xmonad from their home directory or something like that. So I'd rather not Require xmonad when it's not needed.

> Maybe we need a way to force the user to don't install the base package
> only, which wouldn't make sense. Either -gnome or -xfce should be needed. My
> idea: Add a "Provides: xmonad-log-applet-foo" to both packages and vice
> versa a "Requires: xmonad-log-applet-foo" to the main package. But I don't
> know if Yum can solve this correctly. I assume that the user will be asked
> for installing each of the packages.

This is the kind of problem we can avoid if there is no base package :-)

Updated SRPM/spec:
http://fedorapeople.org/~dcallagh/xmonad-log-applet/xmonad-log-applet-2.0.0-3.fc17.src.rpm
http://fedorapeople.org/~dcallagh/xmonad-log-applet/xmonad-log-applet.spec
Comment 8 Mario Blättermann 2012-09-09 14:21:49 EDT
Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=4470039

I was very unsure if it works with the double png file. But I've tested both packages in some different installation and uninstallation scenarios. All seems to be OK, though.

$ rpmlint -i -v *
xmonad-log-applet.src: I: checking
xmonad-log-applet.src: W: spelling-error %description -l en_US workspaces -> work spaces, work-spaces, works paces
The value of this tag appears to be misspelled. Please double-check.

xmonad-log-applet.src: W: spelling-error %description -l en_US hs -> HS, sh, gs
The value of this tag appears to be misspelled. Please double-check.

xmonad-log-applet.src: I: checking-url https://github.com/alexkay/xmonad-log-applet (timeout 10 seconds)
xmonad-log-applet.src: I: checking-url https://github.com/downloads/alexkay/xmonad-log-applet/xmonad-log-applet-2.0.0.tar.gz (timeout 10 seconds)
xmonad-log-applet-debuginfo.i686: I: checking
xmonad-log-applet-debuginfo.i686: I: checking-url https://github.com/alexkay/xmonad-log-applet (timeout 10 seconds)
xmonad-log-applet-debuginfo.x86_64: I: checking
xmonad-log-applet-debuginfo.x86_64: I: checking-url https://github.com/alexkay/xmonad-log-applet (timeout 10 seconds)
xmonad-log-applet-gnome.i686: I: checking
xmonad-log-applet-gnome.i686: W: spelling-error %description -l en_US workspaces -> work spaces, work-spaces, works paces
The value of this tag appears to be misspelled. Please double-check.

xmonad-log-applet-gnome.i686: W: spelling-error %description -l en_US hs -> HS, sh, gs
The value of this tag appears to be misspelled. Please double-check.

xmonad-log-applet-gnome.i686: I: checking-url https://github.com/alexkay/xmonad-log-applet (timeout 10 seconds)
xmonad-log-applet-gnome.x86_64: I: checking
xmonad-log-applet-gnome.x86_64: W: spelling-error %description -l en_US workspaces -> work spaces, work-spaces, works paces
The value of this tag appears to be misspelled. Please double-check.

xmonad-log-applet-gnome.x86_64: W: spelling-error %description -l en_US hs -> HS, sh, gs
The value of this tag appears to be misspelled. Please double-check.

xmonad-log-applet-gnome.x86_64: I: checking-url https://github.com/alexkay/xmonad-log-applet (timeout 10 seconds)
xmonad-log-applet.spec: I: checking-url https://github.com/downloads/alexkay/xmonad-log-applet/xmonad-log-applet-2.0.0.tar.gz (timeout 10 seconds)
xmonad-log-applet-xfce.i686: I: checking
xmonad-log-applet-xfce.i686: W: spelling-error %description -l en_US workspaces -> work spaces, work-spaces, works paces
The value of this tag appears to be misspelled. Please double-check.

xmonad-log-applet-xfce.i686: W: spelling-error %description -l en_US hs -> HS, sh, gs
The value of this tag appears to be misspelled. Please double-check.

xmonad-log-applet-xfce.i686: I: checking-url https://github.com/alexkay/xmonad-log-applet (timeout 10 seconds)
xmonad-log-applet-xfce.x86_64: I: checking
xmonad-log-applet-xfce.x86_64: W: spelling-error %description -l en_US workspaces -> work spaces, work-spaces, works paces
The value of this tag appears to be misspelled. Please double-check.

xmonad-log-applet-xfce.x86_64: W: spelling-error %description -l en_US hs -> HS, sh, gs
The value of this tag appears to be misspelled. Please double-check.

xmonad-log-applet-xfce.x86_64: I: checking-url https://github.com/alexkay/xmonad-log-applet (timeout 10 seconds)
7 packages and 1 specfiles checked; 0 errors, 10 warnings.


Nothing of interest.


---------------------------------
key:

[+] OK
[.] OK, not applicable
[X] needs work
---------------------------------

[+] MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.
[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
[+] MUST: The package must meet the Packaging Guidelines.
[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
[+] MUST: The License field in the package spec file must match the actual license.
    BSD
[.] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use sha256sum for this task as it is used by the sources file once imported into git. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
    $ sha256sum *
    154bdb5b857195b318837ef086ddd3091d100884ada29a146ff18a5589549fa0  xmonad-log-applet-2.0.0.tar.gz
    154bdb5b857195b318837ef086ddd3091d100884ada29a146ff18a5589549fa0  xmonad-log-applet-2.0.0.tar.gz.packaged

[+] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
[.] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
[+] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[.] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[.] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
[+] MUST: Packages must NOT bundle copies of system libraries.
[.] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
[+] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
[+] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
[+] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example.
[+] MUST: Each package must consistently use macros.
[+] MUST: The package must contain code, or permissable content.
[.] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
[+] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
[.] MUST: Static libraries must be in a -static package.
[.] MUST: Development files must be in a -devel package.
[.] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release}
[.] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
[.] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
[+] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
[+] MUST: All filenames in rpm packages must be valid UTF-8.


[.] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[.] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[+] SHOULD: The reviewer should test that the package builds in mock.
    See Koji build above (which uses Mock anyway).
[.] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[+] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[+] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[.] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[.] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
[.] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
[.] SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.

----------------

PACKAGE APPROVED

----------------
Comment 9 Dan Callaghan 2012-09-09 20:45:03 EDT
Thanks Mario!

New Package SCM Request
=======================
Package Name: xmonad-log-applet
Short Description: Panel applet to display Xmonad log information
Owners: dcallagh
Branches: f17 f18
InitialCC:
Comment 10 Gwyn Ciesla 2012-09-09 20:51:25 EDT
Git done (by process-git-requests).
Comment 11 Fedora Update System 2012-09-11 05:57:29 EDT
xmonad-log-applet-2.0.0-3.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/xmonad-log-applet-2.0.0-3.fc17
Comment 12 Fedora Update System 2012-09-11 05:58:11 EDT
xmonad-log-applet-2.0.0-3.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/xmonad-log-applet-2.0.0-3.fc18
Comment 13 Fedora Update System 2012-09-11 20:28:33 EDT
xmonad-log-applet-2.0.0-3.fc17 has been pushed to the Fedora 17 testing repository.
Comment 14 Fedora Update System 2012-09-17 17:53:37 EDT
xmonad-log-applet-2.0.0-3.fc18 has been pushed to the Fedora 18 stable repository.
Comment 15 Fedora Update System 2012-09-21 20:11:52 EDT
xmonad-log-applet-2.0.0-3.fc17 has been pushed to the Fedora 17 stable repository.

Note You need to log in before you can comment on or make changes to this bug.